Subject: Re: [wpan-next v2 08/27] net: ieee802154: Drop symbol duration settings when the core does it already

From: Miquel Raynal <[email-masked]>
Date: Wed, 19 Jan 2022 23:26:00 +0100

Hi Alexander,

[email-masked] wrote on Tue, 18 Jan 2022 17:43:00 -0500:

> Hi,
> 
> On Tue, 18 Jan 2022 at 05:38, Miquel Raynal <[email-masked]> wrote:
> >
> > Hi Alexander,
> >  
> > > > > btw:
> > > > > Also for testing with hwsim and the missing features which currently
> > > > > exist. Can we implement some user space test program which replies
> > > > > (active scan) or sends periodically something out via AF_PACKET raw
> > > > > and a monitor interface that should work to test if it is working?  
> > > >
> > > > We already have all this handled, no need for extra software. You can
> > > > test active and passive scans between two hwsim devices already:
> > > >
> > > > # iwpan dev wpan0 beacons send interval 15
> > > > # iwpan dev wpan1 scan type active duration 1
> > > > # iwpan dev wpan0 beacons stop
> > > >
> > > > or
> > > >
> > > > # iwpan dev wpan0 beacons send interval 1
> > > > # iwpan dev wpan1 scan type passive duration 2
> > > > # iwpan dev wpan0 beacons stop
> > > >  
> > > > > Ideally we could do that very easily with scapy (not sure about their
> > > > > _upstream_ 802.15.4 support). I hope I got that right that there is
> > > > > still something missing but we could fake it in such a way (just for
> > > > > hwsim testing).  
> > > >
> > > > I hope the above will match your expectations.
> > > >  
> > >
> > > I need to think and read more about... in my mind is currently the
> > > following question: are not coordinators broadcasting that information
> > > only? Means, isn't that a job for a coordinator?  
> >
> > My understanding right now:
> > - The spec states that coordinators only can send beacons and perform
> >   scans.  
> 
> ok.
> 
> > - I don't yet have the necessary infrastructure to give coordinators
> >   more rights than regular devices or RFDs (but 40+ patches already,
> >   don't worry this is something we have in mind)
> > - Right now this is the user to decide whether a device might answer
> >   beacon requests or not. This will soon become more limited but it
> >   greatly simplifies the logic for now.
> >  
> 
> There was always the idea behind it to make an "coordinator" interface
> type and there is a reason for that because things e.g. filtering
> becomes different than a non-coordinator interface type (known as node
> interface in wpan).
> At the end interface types should make a big difference in how the
> "role" inside the network should be, which you can also see in
> wireless as "station"/"access point" interface devices.
> 
> A non full functional device should then also not be able to act as a
> coordinator e.g. it cannot create coordinator types.

I've added a few more parameters to be able to reflect the type of
device (ffd, rfd, rfd_r/tx) and also eventually its coordinator state.
I've hacked into nl802154 to give these information to the user and let
it device wether the device (if it's an ffd) should act as a
coordinator. This is only a first step before we create a real PAN
creation procedure of course.

I've then adapted the following patches to follow check against the
device/coordinator state to decide if an operation should be aborted or
not.

> However we can still make some -EOPNOTSUPP if something in a different
> way should be done. This clearly breaks userspace and I am not sure if
> we should worry or not worry about it in the current state of
> 802.15.4...
> 
> - Alex

Thanks,
Miquèl